Hex Artifact Content

Artifact 5242f6143a540b1f99d850b43ee8468a16d95386:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 61 70 70 6c 79 5f 70 61 74 63 68 65 73 28 29   apply_patches()
0570: 20 7b 0a 09 6c 6f 63 61 6c 20 70 61 74 63 68 0a   {..local patch.
0580: 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22  ..for patch in "
0590: 24 7b 70 6b 67 64 69 72 7d 2f 70 61 74 63 68 65  ${pkgdir}/patche
05a0: 73 22 2f 2a 3b 20 64 6f 0a 09 09 69 66 20 5b 20  s"/*; do...if [ 
05b0: 21 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 22 20  ! -e "${patch}" 
05c0: 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69  ]; then....conti
05d0: 6e 75 65 0a 09 09 66 69 0a 0a 09 09 63 61 73 65  nue...fi....case
05e0: 20 22 24 7b 70 61 74 63 68 7d 22 20 69 6e 0a 09   "${patch}" in..
05f0: 09 09 2a 2e 64 69 66 66 7c 2a 2e 70 61 74 63 68  ..*.diff|*.patch
0600: 29 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 29 0a 09  ).....;;....*)..
0610: 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 09  ...continue.....
0620: 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69 66 20  ;;...esac....if 
0630: 5b 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 2e 73  [ -e "${patch}.s
0640: 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 69 66  h" ]; then....if
0650: 20 21 20 73 68 20 22 24 7b 70 61 74 63 68 7d 2e   ! sh "${patch}.
0660: 73 68 22 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f  sh"; then.....co
0670: 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 09 09 66  ntinue....fi...f
0680: 69 0a 0a 09 09 70 61 74 63 68 20 2d 70 31 20 3c  i....patch -p1 <
0690: 20 22 24 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e   "${patch}"..don
06a0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
06b0: 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63 6b  rifyRequiredPack
06c0: 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ages() {..local 
06d0: 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e 20 70 6b  pkg pkgdomain pk
06e0: 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63 61 6c 20  gversion..local 
06f0: 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e 66 69 67  pkgdir pkgconfig
0700: 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a 0a 09 66  dir pkgfound...f
0710: 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b 72 65 71  or pkg in "${req
0720: 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09  uire[@]}"; do...
0730: 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a 09 09 70  pkgdomain=''...p
0740: 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a 09 09 70  kgversion=''...p
0750: 6b 67 63 68 61 6e 67 65 73 3d 28 43 46 4c 41 47  kgchanges=(CFLAG
0760: 53 20 4c 44 46 4c 41 47 53 20 50 41 54 48 20 50  S LDFLAGS PATH P
0770: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a  KG_CONFIG_PATH).
0780: 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22  ...case "${pkg}"
0790: 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09 09 09 09   in....*:*).....
07a0: 70 6b 67 63 68 61 6e 67 65 73 3d 28 24 28 65 63  pkgchanges=($(ec
07b0: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
07c0: 74 20 2d 66 20 32 20 2d 64 20 27 3a 27 29 29 0a  t -f 2 -d ':')).
07d0: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
07e0: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
07f0: 66 20 31 20 2d 64 20 27 3a 27 29 22 0a 09 09 09  f 1 -d ':')"....
0800: 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 63 61  .;;...esac....ca
0810: 73 65 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09  se "${pkg}" in..
0820: 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09 70 6b 67  ..*/*@*).....pkg
0830: 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68 6f 20 22  domain="$(echo "
0840: 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d 66  ${pkg}" | cut -f
0850: 20 32 20 2d 64 20 27 40 27 29 22 0a 09 09 09 09   2 -d '@')".....
0860: 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28 65 63  pkgversion="$(ec
0870: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
0880: 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 20 7c 20  t -f 2 -d '/' | 
0890: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29  cut -f 1 -d '@')
08a0: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
08b0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
08c0: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
08d0: 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29 0a 09 09  ...;;....*/*)...
08e0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28  ..pkgversion="$(
08f0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0900: 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 29  cut -f 2 -d '/')
0910: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
0920: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0930: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
0940: 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29 0a 09 09  ...;;....*@*)...
0950: 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65  ..pkgdomain="$(e
0960: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0970: 75 74 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22  ut -f 2 -d '@')"
0980: 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f  .....pkg="$(echo
0990: 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20   "${pkg}" | cut 
09a0: 2d 66 20 31 20 2d 64 20 27 40 27 29 22 0a 09 09  -f 1 -d '@')"...
09b0: 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69  ..;;...esac....i
09c0: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 6f 6d  f [ -z "${pkgdom
09d0: 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  ain}" ]; then...
09e0: 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 7b 64 6f  .pkgdomain="${do
09f0: 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a 09 09 70  main}"...fi....p
0a00: 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09 09 66 6f  kgfound='0'...fo
0a10: 72 20 70 6b 67 64 69 72 20 69 6e 20 22 2f 6f 70  r pkgdir in "/op
0a20: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a30: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a40: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a50: 6f 6e 3a 2d 6c 61 74 65 73 74 7d 20 22 2f 6f 70  on:-latest} "/op
0a60: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a70: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a80: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a90: 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09 09 70 6b  on:-*}; do....pk
0aa0: 67 63 6f 6e 66 69 67 64 69 72 3d 22 24 7b 70 6b  gconfigdir="${pk
0ab0: 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e  gdir}/lib/pkgcon
0ac0: 66 69 67 22 0a 0a 09 09 09 69 66 20 5b 20 21 20  fig".....if [ ! 
0ad0: 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 5d  -d "${pkgdir}" ]
0ae0: 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f 6e 74 69  ; then.....conti
0af0: 6e 75 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20  nue....fi.....# 
0b00: 49 66 20 74 68 65 20 70 61 63 6b 61 67 65 20 76  If the package v
0b10: 65 72 73 69 6f 6e 20 77 61 73 20 75 6e 73 70 65  ersion was unspe
0b20: 63 69 66 69 65 64 2c 20 66 75 6c 6c 79 20 72 65  cified, fully re
0b30: 73 6f 6c 76 65 0a 09 09 09 23 20 74 68 65 20 64  solve....# the d
0b40: 69 72 65 63 74 6f 72 79 20 74 68 61 74 20 77 65  irectory that we
0b50: 20 66 6f 75 6e 64 0a 09 09 09 69 66 20 5b 20 2d   found....if [ -
0b60: 7a 20 22 24 7b 70 6b 67 76 65 72 73 69 6f 6e 7d  z "${pkgversion}
0b70: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b  " ]; then.....pk
0b80: 67 64 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b  gdir="$(readlink
0b90: 20 2d 66 20 22 24 7b 70 6b 67 64 69 72 7d 22 29   -f "${pkgdir}")
0ba0: 22 0a 09 09 09 66 69 0a 0a 09 09 09 70 6b 67 66  "....fi.....pkgf
0bb0: 6f 75 6e 64 3d 27 31 27 0a 0a 09 09 09 66 6f 72  ound='1'.....for
0bc0: 20 70 6b 67 63 68 61 6e 67 65 20 69 6e 20 22 24   pkgchange in "$
0bd0: 7b 70 6b 67 63 68 61 6e 67 65 73 5b 40 5d 7d 22  {pkgchanges[@]}"
0be0: 3b 20 64 6f 0a 09 09 09 09 63 61 73 65 20 22 24  ; do.....case "$
0bf0: 7b 70 6b 67 63 68 61 6e 67 65 7d 22 20 69 6e 0a  {pkgchange}" in.
0c00: 09 09 09 09 09 43 46 4c 41 47 53 29 0a 09 09 09  .....CFLAGS)....
0c10: 09 09 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c  ...CFLAGS="${CFL
0c20: 41 47 53 7d 20 2d 69 73 79 73 74 65 6d 20 24 7b  AGS} -isystem ${
0c30: 70 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  pkgdir}/include"
0c40: 0a 09 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d  .......CPPFLAGS=
0c50: 22 24 7b 43 50 50 46 4c 41 47 53 7d 20 2d 69 73  "${CPPFLAGS} -is
0c60: 79 73 74 65 6d 20 24 7b 70 6b 67 64 69 72 7d 2f  ystem ${pkgdir}/
0c70: 69 6e 63 6c 75 64 65 22 0a 09 09 09 09 09 09 65  include".......e
0c80: 78 70 6f 72 74 20 43 46 4c 41 47 53 20 43 50 50  xport CFLAGS CPP
0c90: 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09  FLAGS.......;;..
0ca0: 09 09 09 09 4c 44 46 4c 41 47 53 29 0a 09 09 09  ....LDFLAGS)....
0cb0: 09 09 09 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44  ...LDFLAGS="${LD
0cc0: 46 4c 41 47 53 7d 20 2d 4c 24 7b 70 6b 67 64 69  FLAGS} -L${pkgdi
0cd0: 72 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 72 70 61 74  r}/lib -Wl,-rpat
0ce0: 68 2c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 22  h,${pkgdir}/lib"
0cf0: 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 4c 44  .......export LD
0d00: 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09  FLAGS.......;;..
0d10: 09 09 09 09 50 41 54 48 29 0a 09 09 09 09 09 09  ....PATH).......
0d20: 50 41 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b  PATH="${PATH}:${
0d30: 70 6b 67 64 69 72 7d 2f 62 69 6e 22 0a 09 09 09  pkgdir}/bin"....
0d40: 09 09 09 65 78 70 6f 72 74 20 50 41 54 48 0a 09  ...export PATH..
0d50: 09 09 09 09 09 3b 3b 0a 09 09 09 09 09 50 4b 47  .....;;......PKG
0d60: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a 09 09  _CONFIG_PATH)...
0d70: 09 09 09 09 69 66 20 5b 20 2d 64 20 22 24 7b 70  ....if [ -d "${p
0d80: 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22 20 5d 3b  kgconfigdir}" ];
0d90: 20 74 68 65 6e 0a 09 09 09 09 09 09 09 50 4b 47   then........PKG
0da0: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 7b  _CONFIG_PATH="${
0db0: 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 7d  PKG_CONFIG_PATH}
0dc0: 3a 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d  :${pkgconfigdir}
0dd0: 22 0a 09 09 09 09 09 09 09 65 78 70 6f 72 74 20  "........export 
0de0: 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 0a  PKG_CONFIG_PATH.
0df0: 09 09 09 09 09 09 66 69 0a 09 09 09 09 09 09 3b  ......fi.......;
0e00: 3b 0a 09 09 09 09 65 73 61 63 0a 09 09 09 64 6f  ;.....esac....do
0e10: 6e 65 0a 09 09 64 6f 6e 65 0a 0a 09 09 69 66 20  ne...done....if 
0e20: 5b 20 22 24 7b 70 6b 67 66 6f 75 6e 64 7d 22 20  [ "${pkgfound}" 
0e30: 3d 20 27 30 27 20 5d 3b 20 74 68 65 6e 0a 09 09  = '0' ]; then...
0e40: 09 64 69 65 20 22 50 61 63 6b 61 67 65 20 24 7b  .die "Package ${
0e50: 70 6b 67 7d 2f 24 7b 70 6b 67 76 65 72 73 69 6f  pkg}/${pkgversio
0e60: 6e 3a 2d 2a 7d 40 24 7b 70 6b 67 64 6f 6d 61 69  n:-*}@${pkgdomai
0e70: 6e 7d 20 6e 6f 74 20 66 6f 75 6e 64 2e 22 0a 09  n} not found."..
0e80: 09 66 69 0a 09 64 6f 6e 65 0a 7d 0a 0a 66 75 6e  .fi..done.}..fun
0e90: 63 74 69 6f 6e 20 76 65 72 69 66 79 50 72 65 72  ction verifyPrer
0ea0: 65 71 75 69 73 69 74 65 73 28 29 20 7b 0a 09 3a  equisites() {..:
0eb0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74  .}..function det
0ec0: 65 72 6d 69 6e 65 4f 73 41 72 63 68 28 29 20 7b  ermineOsArch() {
0ed0: 0a 09 6f 73 3d 22 24 28 75 6e 61 6d 65 20 2d 73  ..os="$(uname -s
0ee0: 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73 65   | dd conv=lcase
0ef0: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a 09   2>/dev/null)"..
0f00: 61 72 63 68 3d 22 24 28 75 6e 61 6d 65 20 2d 6d  arch="$(uname -m
0f10: 20 7c 20 64 64 20 63 6f 6e 76 3d 6c 63 61 73 65   | dd conv=lcase
0f20: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 29 22 0a 0a   2>/dev/null)"..
0f30: 09 63 61 73 65 20 22 24 7b 61 72 63 68 7d 22 20  .case "${arch}" 
0f40: 69 6e 0a 09 09 69 3f 38 36 29 0a 09 09 09 61 72  in...i?86)....ar
0f50: 63 68 3d 27 69 78 38 36 27 0a 09 09 09 3b 3b 0a  ch='ix86'....;;.
0f60: 09 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f  .esac.}..functio
0f70: 6e 20 64 65 74 65 72 6d 69 6e 65 50 72 65 66 69  n determinePrefi
0f80: 78 28 29 20 7b 0a 09 64 65 74 65 72 6d 69 6e 65  x() {..determine
0f90: 4f 73 41 72 63 68 0a 0a 09 70 72 65 66 69 78 73  OsArch...prefixs
0fa0: 75 66 66 69 78 3d 22 24 7b 70 6b 67 7d 2f 24 7b  uffix="${pkg}/${
0fb0: 6f 73 7d 2d 24 7b 61 72 63 68 7d 2f 24 7b 76 65  os}-${arch}/${ve
0fc0: 72 73 69 6f 6e 7d 22 0a 09 70 72 65 66 69 78 3d  rsion}"..prefix=
0fd0: 22 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 64 6f  "/opt/appfs/${do
0fe0: 6d 61 69 6e 7d 2f 24 7b 70 72 65 66 69 78 73 75  main}/${prefixsu
0ff0: 66 66 69 78 7d 22 0a 09 64 65 73 74 64 69 72 3d  ffix}"..destdir=
1000: 22 24 28 70 77 64 29 2f 49 4e 53 54 22 0a 0a 09  "$(pwd)/INST"...
1010: 6d 6b 64 69 72 20 22 24 7b 64 65 73 74 64 69 72  mkdir "${destdir
1020: 7d 22 20 7c 7c 20 64 69 65 0a 7d 0a 0a 66 75 6e  }" || die.}..fun
1030: 63 74 69 6f 6e 20 70 72 65 63 6f 6e 66 69 67 75  ction preconfigu
1040: 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  re() {..:.}..fun
1050: 63 74 69 6f 6e 20 70 6f 73 74 63 6f 6e 66 69 67  ction postconfig
1060: 75 72 65 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ure() {..:.}..fu
1070: 6e 63 74 69 6f 6e 20 63 6f 6e 66 69 67 75 72 65  nction configure
1080: 5f 67 63 63 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  _gcc() {..local 
1090: 67 6c 69 62 63 64 69 72 20 6c 69 6e 75 78 68 65  glibcdir linuxhe
10a0: 61 64 65 72 73 64 69 72 0a 09 6c 6f 63 61 6c 20  adersdir..local 
10b0: 64 79 6e 6c 69 6e 6b 65 72 0a 09 6c 6f 63 61 6c  dynlinker..local
10c0: 20 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65 61   gcc_default_hea
10d0: 64 65 72 73 0a 0a 09 67 6c 69 62 63 64 69 72 3d  ders...glibcdir=
10e0: 22 2f 6f 70 74 2f 61 70 70 66 73 2f 63 6f 72 65  "/opt/appfs/core
10f0: 2e 61 70 70 66 73 2e 72 6b 65 65 6e 65 2e 6f 72  .appfs.rkeene.or
1100: 67 2f 67 6c 69 62 63 2f 70 6c 61 74 66 6f 72 6d  g/glibc/platform
1110: 2f 6c 61 74 65 73 74 22 0a 09 67 6c 69 62 63 64  /latest"..glibcd
1120: 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b 20 2d  ir="$(readlink -
1130: 66 20 22 24 7b 67 6c 69 62 63 64 69 72 7d 22 29  f "${glibcdir}")
1140: 22 0a 0a 09 6c 69 6e 75 78 68 65 61 64 65 72 73  "...linuxheaders
1150: 64 69 72 3d 22 2f 6f 70 74 2f 61 70 70 66 73 2f  dir="/opt/appfs/
1160: 63 6f 72 65 2e 61 70 70 66 73 2e 72 6b 65 65 6e  core.appfs.rkeen
1170: 65 2e 6f 72 67 2f 6c 69 6e 75 78 2d 68 65 61 64  e.org/linux-head
1180: 65 72 73 2f 70 6c 61 74 66 6f 72 6d 2f 6c 61 74  ers/platform/lat
1190: 65 73 74 22 0a 09 6c 69 6e 75 78 68 65 61 64 65  est"..linuxheade
11a0: 72 73 64 69 72 3d 22 24 28 72 65 61 64 6c 69 6e  rsdir="$(readlin
11b0: 6b 20 2d 66 20 22 24 7b 6c 69 6e 75 78 68 65 61  k -f "${linuxhea
11c0: 64 65 72 73 64 69 72 7d 22 29 22 0a 0a 09 64 79  dersdir}")"...dy
11d0: 6e 6c 69 6e 6b 65 72 3d 22 24 28 6c 73 20 22 24  nlinker="$(ls "$
11e0: 7b 67 6c 69 62 63 64 69 72 7d 22 2f 6c 69 62 2f  {glibcdir}"/lib/
11f0: 6c 64 2d 6c 69 6e 75 78 2a 2e 73 6f 2e 2a 20 7c  ld-linux*.so.* |
1200: 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 0a 09 69   tail -n 1)"...i
1210: 66 20 5b 20 21 20 2d 66 20 22 24 7b 64 79 6e 6c  f [ ! -f "${dynl
1220: 69 6e 6b 65 72 7d 22 20 5d 3b 20 74 68 65 6e 0a  inker}" ]; then.
1230: 09 09 64 69 65 20 27 67 6c 69 62 63 20 64 69 72  ..die 'glibc dir
1240: 65 63 74 6f 72 79 20 69 73 20 6e 6f 74 20 61 76  ectory is not av
1250: 61 69 6c 61 62 6c 65 20 28 61 70 70 66 73 20 72  ailable (appfs r
1260: 75 6e 6e 69 6e 67 2f 77 6f 72 6b 69 6e 67 3f 29  unning/working?)
1270: 27 0a 09 66 69 0a 0a 09 67 63 63 5f 64 65 66 61  '..fi...gcc_defa
1280: 75 6c 74 5f 68 65 61 64 65 72 73 3d 22 24 28 65  ult_headers="$(e
1290: 63 68 6f 20 27 27 20 7c 20 24 7b 43 50 50 3a 2d  cho '' | ${CPP:-
12a0: 63 70 70 7d 20 2d 76 20 32 3e 26 31 20 7c 20 73  cpp} -v 2>&1 | s
12b0: 65 64 20 27 2f 5e 45 6e 64 20 6f 66 20 73 65 61  ed '/^End of sea
12c0: 72 63 68 20 6c 69 73 74 2f 2c 24 20 64 3b 30 2c  rch list/,$ d;0,
12d0: 2f 73 65 61 72 63 68 20 73 74 61 72 74 73 20 68  /search starts h
12e0: 65 72 65 3a 24 2f 20 64 27 20 7c 20 67 72 65 70  ere:$/ d' | grep
12f0: 20 27 2f 67 63 63 2f 27 20 7c 20 73 65 64 20 27   '/gcc/' | sed '
1300: 73 40 5e 20 2a 40 2d 69 73 79 73 74 65 6d 20 40  s@^ *@-isystem @
1310: 27 20 7c 20 74 72 20 24 27 5c 6e 27 20 27 20 27  ' | tr $'\n' ' '
1320: 29 22 0a 0a 09 43 43 3d 22 24 7b 43 43 3a 2d 67  )"...CC="${CC:-g
1330: 63 63 7d 20 2d 6e 6f 73 74 64 69 6e 63 20 24 7b  cc} -nostdinc ${
1340: 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65 61 64  gcc_default_head
1350: 65 72 73 7d 20 2d 69 73 79 73 74 65 6d 20 24 7b  ers} -isystem ${
1360: 67 6c 69 62 63 64 69 72 7d 2f 69 6e 63 6c 75 64  glibcdir}/includ
1370: 65 22 0a 0a 09 69 66 20 21 20 65 63 68 6f 20 22  e"...if ! echo "
1380: 20 24 7b 72 65 71 75 69 72 65 5b 2a 5d 7d 20 22   ${require[*]} "
1390: 20 7c 20 67 72 65 70 20 27 20 6c 69 6e 75 78 2d   | grep ' linux-
13a0: 68 65 61 64 65 72 73 5b 2f 40 3a 20 5d 27 20 3e  headers[/@: ]' >
13b0: 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a  /dev/null; then.
13c0: 09 09 43 43 3d 22 24 7b 43 43 7d 20 2d 69 73 79  ..CC="${CC} -isy
13d0: 73 74 65 6d 20 24 7b 6c 69 6e 75 78 68 65 61 64  stem ${linuxhead
13e0: 65 72 73 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  ersdir}/include"
13f0: 0a 09 66 69 0a 0a 09 42 55 49 4c 44 5f 43 43 3d  ..fi...BUILD_CC=
1400: 22 24 7b 43 43 7d 22 0a 09 48 4f 53 54 5f 43 43  "${CC}"..HOST_CC
1410: 3d 22 24 7b 43 43 7d 22 0a 0a 09 4c 44 46 4c 41  ="${CC}"...LDFLA
1420: 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d  GS="${LDFLAGS} -
1430: 4c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62  L${glibcdir}/lib
1440: 20 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c 24 7b 67   -Wl,--rpath,${g
1450: 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c  libcdir}/lib -Wl
1460: 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65  ,--dynamic-linke
1470: 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a  r,${dynlinker}".
1480: 09 69 66 20 5b 20 2d 7a 20 22 24 7b 61 70 70 66  .if [ -z "${appf
1490: 73 5f 62 75 69 6c 64 5f 6e 6f 5f 64 65 66 61 75  s_build_no_defau
14a0: 6c 74 5f 73 79 6d 76 65 72 7d 22 20 5d 3b 20 74  lt_symver}" ]; t
14b0: 68 65 6e 0a 09 09 4c 44 46 4c 41 47 53 3d 22 24  hen...LDFLAGS="$
14c0: 7b 4c 44 46 4c 41 47 53 7d 20 2d 57 6c 2c 2d 2d  {LDFLAGS} -Wl,--
14d0: 64 65 66 61 75 6c 74 2d 73 79 6d 76 65 72 22 0a  default-symver".
14e0: 09 66 69 0a 0a 09 50 4b 47 5f 43 4f 4e 46 49 47  .fi...PKG_CONFIG
14f0: 5f 4c 49 42 44 49 52 3d 22 24 7b 67 6c 69 62 63  _LIBDIR="${glibc
1500: 64 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66  dir}/lib/pkgconf
1510: 69 67 22 0a 0a 09 65 78 70 6f 72 74 20 43 43 20  ig"...export CC 
1520: 42 55 49 4c 44 5f 43 43 20 48 4f 53 54 5f 43 43  BUILD_CC HOST_CC
1530: 20 4c 44 46 4c 41 47 53 20 50 4b 47 5f 43 4f 4e   LDFLAGS PKG_CON
1540: 46 49 47 5f 4c 49 42 44 49 52 0a 7d 0a 0a 66 75  FIG_LIBDIR.}..fu
1550: 6e 63 74 69 6f 6e 20 63 6f 6e 66 69 67 75 72 65  nction configure
1560: 28 29 20 7b 0a 09 63 6f 6e 66 69 67 75 72 65 5f  () {..configure_
1570: 67 63 63 0a 09 2e 2f 63 6f 6e 66 69 67 75 72 65  gcc.../configure
1580: 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70 72 65   --prefix="${pre
1590: 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e 66 64  fix}" --sysconfd
15a0: 69 72 3d 22 24 7b 70 72 65 66 69 78 7d 2f 65 74  ir="${prefix}/et
15b0: 63 22 20 2d 2d 6c 69 62 64 69 72 3d 22 24 7b 70  c" --libdir="${p
15c0: 72 65 66 69 78 7d 2f 6c 69 62 22 20 2d 2d 6c 6f  refix}/lib" --lo
15d0: 63 61 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72  calstatedir=/var
15e0: 20 22 24 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78   "${configure_ex
15f0: 74 72 61 5b 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63  tra[@]}".}..func
1600: 74 69 6f 6e 20 70 72 65 62 75 69 6c 64 28 29 20  tion prebuild() 
1610: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
1620: 20 70 6f 73 74 62 75 69 6c 64 28 29 20 7b 0a 09   postbuild() {..
1630: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75  :.}..function bu
1640: 69 6c 64 28 29 20 7b 0a 09 67 72 65 70 20 22 44  ild() {..grep "D
1650: 45 53 54 44 49 52 22 20 4d 61 6b 65 66 69 6c 65  ESTDIR" Makefile
1660: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 64   >/dev/null || d
1670: 69 65 20 22 44 6f 6e 27 74 20 6b 6e 6f 77 20 68  ie "Don't know h
1680: 6f 77 20 74 6f 20 62 75 69 6c 64 20 74 68 69 73  ow to build this
1690: 20 73 6f 66 74 77 61 72 65 22 0a 0a 09 6d 61 6b   software"...mak
16a0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  e.}..function pr
16b0: 65 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a  einstall() {..:.
16c0: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74  }..function post
16d0: 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d  install() {..:.}
16e0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 69 6e 73 74 61  ..function insta
16f0: 6c 6c 28 29 20 7b 0a 09 6d 61 6b 65 20 69 6e 73  ll() {..make ins
1700: 74 61 6c 6c 20 44 45 53 54 44 49 52 3d 22 24 7b  tall DESTDIR="${
1710: 64 65 73 74 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e  destdir}".}..fun
1720: 63 74 69 6f 6e 20 63 6c 65 61 6e 75 70 28 29 20  ction cleanup() 
1730: 7b 0a 09 63 64 20 22 24 7b 77 6f 72 6b 64 69 72  {..cd "${workdir
1740: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 64  }" || exit 1..cd
1750: 20 2e 2e 20 7c 7c 20 65 78 69 74 20 31 0a 09 72   .. || exit 1..r
1760: 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69 72  m -rf "${workdir
1770: 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64  }".}..function d
1780: 69 65 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 6d 65  ie() {..local me
1790: 73 73 61 67 65 0a 0a 09 6d 65 73 73 61 67 65 3d  ssage...message=
17a0: 22 24 31 22 0a 0a 09 69 66 20 5b 20 2d 6e 20 22  "$1"...if [ -n "
17b0: 24 7b 6d 65 73 73 61 67 65 7d 22 20 5d 3b 20 74  ${message}" ]; t
17c0: 68 65 6e 0a 09 09 65 63 68 6f 20 22 65 72 72 6f  hen...echo "erro
17d0: 72 3a 20 24 7b 6d 65 73 73 61 67 65 7d 22 20 3e  r: ${message}" >
17e0: 26 32 0a 09 66 69 0a 0a 09 65 78 69 74 20 31 0a  &2..fi...exit 1.
17f0: 7d 0a 0a 73 63 72 69 70 74 64 69 72 3d 22 24 28  }..scriptdir="$(
1800: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
1810: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
1820: 26 26 20 70 77 64 29 22 0a 69 66 20 5b 20 2d 7a  && pwd)".if [ -z
1830: 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20   "${scriptdir}" 
1840: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 55  ]; then..echo "U
1850: 6e 61 62 6c 65 20 74 6f 20 6c 6f 63 61 74 65 20  nable to locate 
1860: 73 63 72 69 70 74 20 64 69 72 65 63 74 6f 72 79  script directory
1870: 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66  " >&2...exit 1.f
1880: 69 0a 0a 63 64 20 22 24 7b 73 63 72 69 70 74 64  i..cd "${scriptd
1890: 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  ir}" || exit 1..
18a0: 69 66 20 5b 20 2d 66 20 27 62 75 69 6c 64 2e 63  if [ -f 'build.c
18b0: 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a 09 2e 20  onf' ]; then... 
18c0: 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a  'build.conf'.fi.
18d0: 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67 73 2f 24  .if [ -d "pkgs/$
18e0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
18f0: 70 6b 67 64 69 72 3d 22 24 28 70 77 64 29 2f 70  pkgdir="$(pwd)/p
1900: 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67  kgs/${pkg}"..pkg
1910: 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69 72 7d 2f  file="${pkgdir}/
1920: 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70 6b 67 66  info".else..pkgf
1930: 69 6c 65 3d 22 24 28 70 77 64 29 2f 70 6b 67 73  ile="$(pwd)/pkgs
1940: 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 64 69 72  /${pkg}"..pkgdir
1950: 3d 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 66 69  ="${pkgfile}".fi
1960: 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70  ..if [ ! -e "${p
1970: 6b 67 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e  kgfile}" ]; then
1980: 0a 09 65 63 68 6f 20 22 49 6e 76 61 6c 69 64 20  ..echo "Invalid 
1990: 70 61 63 6b 61 67 65 2e 22 20 3e 26 32 0a 0a 09  package." >&2...
19a0: 65 78 69 74 20 31 0a 66 69 0a 0a 70 6b 67 64 61  exit 1.fi..pkgda
19b0: 74 65 3d 22 24 28 66 6f 72 20 61 72 74 69 66 61  te="$(for artifa
19c0: 63 74 20 69 6e 20 24 28 66 69 6e 64 20 22 24 7b  ct in $(find "${
19d0: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
19e0: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
19f0: 20 2d 6e 20 31 20 2d 30 20 66 6f 73 73 69 6c 20   -n 1 -0 fossil 
1a00: 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20 31 20  finfo --limit 1 
1a10: 2d 2d 77 69 64 74 68 20 30 20 32 3e 2f 64 65 76  --width 0 2>/dev
1a20: 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 27 5e 5b  /null | grep '^[
1a30: 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30  0-9][0-9][0-9][0
1a40: 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b  -9]-[0-9][0-9]-[
1a50: 30 2d 39 5d 5b 30 2d 39 5d 20 27 20 7c 20 73 65  0-9][0-9] ' | se
1a60: 64 20 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b 40 40  d 's@^[^ ]* \[@@
1a70: 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c 20 73 6f 72  ;s@\].*@@' | sor
1a80: 74 20 2d 75 29 3b 20 64 6f 20 66 6f 73 73 69 6c  t -u); do fossil
1a90: 20 69 6e 66 6f 20 22 24 7b 61 72 74 69 66 61 63   info "${artifac
1aa0: 74 7d 22 20 7c 20 61 77 6b 20 27 2f 5e 75 75 69  t}" | awk '/^uui
1ab0: 64 3a 2f 7b 20 70 72 69 6e 74 20 24 33 20 24 34  d:/{ print $3 $4
1ac0: 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5b 2d 3a   }' | sed 's@[-:
1ad0: 5d 40 40 67 3b 73 40 2e 2e 24 40 5c 2e 26 40 27  ]@@g;s@..$@\.&@'
1ae0: 3b 20 64 6f 6e 65 20 7c 20 73 6f 72 74 20 2d 6e  ; done | sort -n
1af0: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 69   | tail -n 1)".i
1b00: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 61 74  f [ -z "${pkgdat
1b10: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67  e}" ]; then..pkg
1b20: 64 61 74 65 3d 22 24 28 66 69 6e 64 20 22 24 7b  date="$(find "${
1b30: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
1b40: 20 2d 70 72 69 6e 74 66 20 27 25 54 59 25 54 6d   -printf '%TY%Tm
1b50: 25 54 64 25 54 48 25 54 4d 2e 25 54 53 5c 6e 27  %Td%TH%TM.%TS\n'
1b60: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 63   2>/dev/null | c
1b70: 75 74 20 2d 66 20 31 2d 32 20 2d 64 20 27 2e 27  ut -f 1-2 -d '.'
1b80: 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69   | sort -n | tai
1b90: 6c 20 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e 20 22  l -n 1)".fi... "
1ba0: 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61 72 63  ${pkgfile}"..arc
1bb0: 68 69 76 65 64 69 72 3d 22 24 28 70 77 64 29 2f  hivedir="$(pwd)/
1bc0: 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64 69 72  ARCHIVE".workdir
1bd0: 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b 52 41  ="workdir-$$${RA
1be0: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
1bf0: 52 41 4e 44 4f 4d 7d 22 0a 70 6b 67 61 72 63 68  RANDOM}".pkgarch
1c00: 69 76 65 3d 22 24 7b 61 72 63 68 69 76 65 64 69  ive="${archivedi
1c10: 72 7d 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73  r}/${pkg}-${vers
1c20: 69 6f 6e 7d 22 0a 6d 6b 64 69 72 20 22 24 7b 61  ion}".mkdir "${a
1c30: 72 63 68 69 76 65 64 69 72 7d 22 20 3e 2f 64 65  rchivedir}" >/de
1c40: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
1c50: 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b 77 6f 72 6b  ll.mkdir "${work
1c60: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
1c70: 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  cd "${workdir}" 
1c80: 7c 7c 20 65 78 69 74 20 31 0a 77 6f 72 6b 64 69  || exit 1.workdi
1c90: 72 3d 22 24 28 70 77 64 29 22 0a 0a 23 20 44 6f  r="$(pwd)"..# Do
1ca0: 77 6e 6c 6f 61 64 0a 64 6f 77 6e 6c 6f 61 64 0a  wnload.download.
1cb0: 0a 23 20 45 78 74 72 61 63 74 0a 65 78 74 72 61  .# Extract.extra
1cc0: 63 74 0a 0a 23 20 49 66 20 77 65 20 6a 75 73 74  ct..# If we just
1cd0: 20 68 61 76 65 20 6f 6e 65 20 64 69 72 65 63 74   have one direct
1ce0: 6f 72 79 2c 20 75 73 65 20 74 68 61 74 20 64 69  ory, use that di
1cf0: 72 65 63 74 6f 72 79 0a 64 69 72 3d 22 24 28 65  rectory.dir="$(e
1d00: 63 68 6f 20 2a 29 22 0a 69 66 20 5b 20 2d 65 20  cho *)".if [ -e 
1d10: 22 24 7b 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e  "${dir}" ]; then
1d20: 0a 09 6d 76 20 22 24 7b 64 69 72 7d 22 2f 2a 20  ..mv "${dir}"/* 
1d30: 2e 0a 66 69 0a 0a 23 20 56 65 72 69 66 79 20 70  ..fi..# Verify p
1d40: 72 65 2d 72 65 71 75 69 73 69 74 65 73 20 61 72  re-requisites ar
1d50: 65 20 6d 65 74 0a 76 65 72 69 66 79 52 65 71 75  e met.verifyRequ
1d60: 69 72 65 64 50 61 63 6b 61 67 65 73 20 7c 7c 20  iredPackages || 
1d70: 64 69 65 20 27 52 65 71 75 69 72 65 64 20 70 61  die 'Required pa
1d80: 63 6b 61 67 65 73 20 6d 69 73 73 69 6e 67 27 0a  ckages missing'.
1d90: 76 65 72 69 66 79 50 72 65 72 65 71 75 69 73 69  verifyPrerequisi
1da0: 74 65 73 20 7c 7c 20 64 69 65 20 27 50 72 65 72  tes || die 'Prer
1db0: 65 71 75 69 73 69 74 69 65 73 20 66 61 69 6c 65  equisities faile
1dc0: 64 27 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67  d'..# Start logg
1dd0: 69 6e 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65  ing.set -x..# De
1de0: 74 65 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69  termine properti
1df0: 65 73 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66  es.determinePref
1e00: 69 78 0a 0a 23 20 41 70 70 6c 79 20 70 61 74 63  ix..# Apply patc
1e10: 68 65 73 0a 61 70 70 6c 79 5f 70 61 74 63 68 65  hes.apply_patche
1e20: 73 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20 62  s..# Start the b
1e30: 75 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75 72  uild.preconfigur
1e40: 65 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e  e || die 'precon
1e50: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 63  figure failed'.c
1e60: 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20  onfigure || die 
1e70: 27 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65  'configure faile
1e80: 64 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72 65  d'.postconfigure
1e90: 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f 6e   || die 'postcon
1ea0: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 0a  figure failed'..
1eb0: 70 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20  prebuild || die 
1ec0: 27 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64  'prebuild failed
1ed0: 27 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  '.build || die '
1ee0: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f  build failed'.po
1ef0: 73 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  stbuild || die '
1f00: 70 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64  postbuild failed
1f10: 27 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c  '..preinstall ||
1f20: 20 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c   die 'preinstall
1f30: 20 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c   failed'.install
1f40: 20 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c 6c   || die 'install
1f50: 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73   failed'.postins
1f60: 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73  tall || die 'pos
1f70: 74 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27  tinstall failed'
1f80: 0a 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61 72  ..(..case "${tar
1f90: 67 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69  getmode}" in...i
1fa0: 6e 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64 69  nstall)....appdi
1fb0: 72 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c  r="$(appfsinstal
1fc0: 6c 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75  ldir)/${prefixsu
1fd0: 66 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20  ffix}"....mkdir 
1fe0: 2d 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a  -p "${appdir}"..
1ff0: 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72  ...cd "${destdir
2000: 7d 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20  }/${prefix}" || 
2010: 65 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d 72  exit 1.....cp -r
2020: 70 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a  p * "${appdir}".
2030: 09 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69  ...find "${appdi
2040: 72 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61  r}" -print0 | xa
2050: 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20  rgs -0 touch -t 
2060: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
2070: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
2080: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
2090: 20 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20   -0 touch -m -t 
20a0: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
20b0: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
20c0: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
20d0: 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20   -0 touch -a -t 
20e0: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
20f0: 3b 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09 09  ;;...archive)...
2100: 09 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24 7b  .archivefile="${
2110: 73 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67  scriptdir}/${pkg
2120: 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65  }-${version}-$(e
2130: 63 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d 22  cho "${pkgdate}"
2140: 20 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67 27   | sed 's@\.@@g'
2150: 29 2d 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d  )-${os}-${arch}-
2160: 24 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a  ${domain}.cpio".
2170: 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72  ...cd "${destdir
2180: 7d 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e  }/${prefix}/../.
2190: 2e 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a  ./.." || exit 1.
21a0: 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69  ...find "${prefi
21b0: 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74  xsuffix}" -print
21c0: 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75  0 | xargs -0 tou
21d0: 63 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  ch -t "${pkgdate
21e0: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72  }"....find "${pr
21f0: 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72  efixsuffix}" -pr
2200: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
2210: 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70  touch -m -t "${p
2220: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
2230: 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78   "${prefixsuffix
2240: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
2250: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d  gs -0 touch -a -
2260: 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09  t "${pkgdate}"..
2270: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
2280: 73 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20  suffix}" | sort 
2290: 7c 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30  | cpio --owner 0
22a0: 3a 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20  :0 -H newc -o > 
22b0: 22 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22  "${archivefile}"
22c0: 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c  ....;;..esac.) |
22d0: 7c 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73  | die 'final ins
22e0: 74 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64  tallation failed
22f0: 27 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74  '..cleanup..exit
2300: 20 30 0a                                          0.